-- #####################################################################
--  Chapter 5: Exercise 1
-- #####################################################################

SELECT Count(*)
FROM TBL_EMPLOYEE
WHERE TYPE='COOK';

-- #####################################################################
--  Chapter 5: Exercise 2
-- #####################################################################

SELECT AVG(PRICE)
FROM TBL_PRODUCT;

-- #####################################################################
--  Chapter 5: Exercise 3
-- #####################################################################

SELECT  bp.ORDER_NO,
        SUM(COUNT*PRICE)
FROM TBL_ORDER_POS bp
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
GROUP BY bp.ORDER_NO
ORDER BY 1;

-- #####################################################################
--  Chapter 5: Exercise 4
-- #####################################################################

SELECT k.CITY, SUM(bp.COUNT*p.PRICE) AS TURNOVER
FROM TBL_CUSTOMERS k
  JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
  JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
GROUP BY k.CITY
ORDER BY 2 DESC;

-- #####################################################################
--  Chapter 5: Exercise 5
-- #####################################################################

SELECT  pg.PRODUCT_GROUP_NO,
        pg.NAME,
        AVG(p.PRICE)
FROM TBL_PRODUCT_GROUP pg
  JOIN TBL_PRODUCT p ON pg.PRODUCT_GROUP_NO=p.PRODUCT_GROUP_NO
GROUP BY  pg.PRODUCT_GROUP_NO,
          pg.NAME
HAVING AVG(p.PRICE)>6;

-- #####################################################################
--  Chapter 5: Exercise 1
-- #####################################################################

SELECT m.EMPLOYEE_NO, m.SURNAME, m.FIRSTNAME, SUM(bp.COUNT)
FROM TBL_ORDER b
  JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  JOIN TBL_EMPLOYEE m ON b.DRIVER_NO=m.EMPLOYEE_NO
  JOIN TBL_PRODUCT p ON p.PRODUCT_NO=bp.PRODUCT_NO
WHERE p.PRODUCT_GROUP_NO=2 --> Pizzen
GROUP BY m.EMPLOYEE_NO, m.SURNAME, m.FIRSTNAME
ORDER BY 4 DESC;

--> Deutlich zu sehen, dass Peter Peters die meisten Pizzen ausgeliefert hat.

-- #####################################################################
--  Chapter 5: Exercise 2
-- #####################################################################

SELECT CUSTOMER_NO, Count(distinct ORDER_NO) AS ANZ_BESTELLUNGEN
FROM TBL_ORDER
WHERE ORDER_DATE between to_Date('01.04.2013', 'DD.MM.YYYY') and to_Date('30.06.2013', 'DD.MM.YYYY')
GROUP BY CUSTOMER_NO
order by 2 DESC;

-- #####################################################################
--  Chapter 5: Exercise 3
-- #####################################################################

SELECT 	p.PRODUCT_NO,
	p.NAME,
	SUM(bp.COUNT) AS VK_STUECK
FROM TBL_ORDER b
	JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
	JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
WHERE b.ORDER_DATE BETWEEN '01.03.2013' AND '31.03.2013'
GROUP BY p.PRODUCT_NO,
	p.NAME
ORDER BY 3 ASC;

--> You can read the result in the list. Water is the product that was sold worst.

-- #####################################################################
--  Chapter 5: Exercise 4
-- #####################################################################

SELECT  pg.PRODUCT_GROUP_NO,
        pg.NAME,
        to_char(b.ORDER_DATE,'MM/YYYY') AS MONAT,
        SUM(bp.COUNT*p.PRICE)
FROM TBL_PRODUCT_GROUP pg
  JOIN TBL_PRODUCT p ON pg.PRODUCT_GROUP_NO=p.PRODUCT_GROUP_NO
  JOIN TBL_ORDER_POS bp ON bp.PRODUCT_NO=p.PRODUCT_NO
  JOIN TBL_ORDER b ON bp.ORDER_NO=b.ORDER_NO
WHERE to_char(b.ORDER_DATE,'YYYYMM') BETWEEN 201303 AND 201305
GROUP BY pg.PRODUCT_GROUP_NO,
        pg.NAME,
        to_char(b.ORDER_DATE,'MM/YYYY') 
ORDER BY 1,3;     

-- #####################################################################
--  Chapter 5: Exercise 5
-- #####################################################################

SELECT  p.PRODUCT_NO, 
        p.NAME,
        SUM(bp.COUNT*p.PRICE) AS TURNOVER
FROM TBL_PRODUCT p
  LEFT JOIN TBL_ORDER_POS bp ON p.PRODUCT_NO=bp.PRODUCT_NO
  LEFT JOIN TBL_ORDER b ON bp.ORDER_NO=b.ORDER_NO
WHERE (to_char(b.ORDER_DATE,'YYYYQ')='20131' OR b.ORDER_DATE IS NULL)
GROUP BY  p.PRODUCT_NO, 
          p.NAME
ORDER BY 3 DESC NULLS LAST;
          
-- #####################################################################
--  Chapter 5: Exercise 6
-- #####################################################################

SELECT  m.EMPLOYEE_NO,
        m.SURNAME,
        m.FIRSTNAME,
        Count(distinct b.CUSTOMER_NO) AS ANZ_KUNDEN,
        Count(b.ORDER_NO) AS ANZ_BEST
FROM TBL_EMPLOYEE m
  JOIN TBL_ORDER b ON m.EMPLOYEE_NO=b.DRIVER_NO
GROUP BY  m.EMPLOYEE_NO,
        m.SURNAME,
        m.FIRSTNAME;
          

-- #####################################################################
--  Chapter 5: Exercise 7
-- #####################################################################

SELECT  k.CITY,
        COUNT(distinct b.ORDER_NO) AS ANZ_BEST,
        SUM(bp.COUNT*p.PRICE) AS TURNOVER,
        ROUND(SUM(bp.COUNT*p.PRICE)/COUNT(distinct b.ORDER_NO),2) AS AVG_UMS_PRO_BEST
FROM TBL_CUSTOMERS k
  JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
  JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
GROUP BY k.CITY
ORDER BY 4 DESC;

-- #####################################################################
--  Chapter 5: Exercise 8
-- #####################################################################

SELECT  m.EMPLOYEE_NO,
        FIRSTNAME,
        SURNAME,
        SUM(bp.COUNT*p.PRICE) AS TURNOVER,
        SUM(bp.COUNT*p.PRICE*m.PROV_FACTOR) AS PROVISION
FROM TBL_EMPLOYEE m
  LEFT JOIN TBL_ORDER b ON m.EMPLOYEE_NO=b.SALES_AGENT_NO
  LEFT JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  LEFT JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
WHERE TYPE='SALES AGENT'
GROUP BY m.EMPLOYEE_NO,
        FIRSTNAME,
        SURNAME 
ORDER BY 5 DESC;
