-- #####################################################################
--  Chapter 6: Example 1 (page 39)
-- #####################################################################

SELECT AVG(COUNT)
FROM (
      SELECT PRODUCT_GROUP_NO, Count(PRODUCT_NO) AS COUNT
      FROM TBL_PRODUCT
      GROUP BY PRODUCT_GROUP_NO
);

-- #####################################################################
--  Chapter 6: Example 2 (page 40)
-- #####################################################################

SELECT PRODUCT_GROUP_NO AS NO, NAME AS GROUP_NAME
FROM TBL_PRODUCT_GROUP
WHERE PRODUCT_GROUP_NO NOT IN (
                              SELECT DISTINCT PRODUCT_GROUP_NO
                              FROM TBL_PRODUCT
                              );

-- #####################################################################
--  Chapter 6: Example 3 (page 40)
-- #####################################################################

SELECT PRODUCT_NO, NAME, PRICE
FROM TBL_PRODUCT
WHERE PRICE>= (
        SELECT AVG(PRICE)
        FROM TBL_PRODUCT
);

-- #####################################################################
--  Chapter 6: Example 4 (page 41)
-- #####################################################################

SELECT  grp.NAME AS GROUP_NAME, 
        PRODUCT_NO AS NO, 
        p_main.NAME AS PRODUCT, 
        PRICE,
        (     SELECT AVG(PRICE)
              FROM TBL_PRODUCT p_sub
              WHERE p_sub.PRODUCT_GROUP_NO=p_main.PRODUCT_GROUP_NO
        ) AS GRP_AVG
FROM TBL_PRODUCT p_main
  JOIN TBL_PRODUCT_GROUP grp ON p_main.PRODUCT_GROUP_NO=grp.PRODUCT_GROUP_NO
WHERE p_main.PRICE>=(
    SELECT AVG(PRICE)
    FROM TBL_PRODUCT p_sub
    WHERE p_sub.PRODUCT_GROUP_NO=p_main.PRODUCT_GROUP_NO
);


-- #####################################################################
--  Chapter 6: Example 5 (page 42)
-- #####################################################################

SELECT *
FROM TBL_PRODUCT_GROUP grp
WHERE NOT EXISTS (
    SELECT 1 
    FROM TBL_PRODUCT prd
    WHERE prd.PRODUCT_GROUP_NO=grp.PRODUCT_GROUP_NO
);

-- #####################################################################
--  Chapter 6: Example 6 (page 42)
-- #####################################################################

CREATE TABLE TBL_CUSTOMER_TEST AS
SELECT *
FROM TBL_CUSTOMER;

-- #####################################################################
--  Chapter 6: Example 7 (page 40)
-- #####################################################################

TRUNCATE TABLE TBL_CUSTOMER_TEST;

INSERT INTO TBL_CUSTOMER_TEST (CUSTOMER_NO, FIRSTNAME, SURNAME)
SELECT CUSTOMER_NO, FIRSTNAME, SURNAME
FROM TBL_CUSTOMER;

COMMIT;

-- #####################################################################
--  Chapter 6: Example 8 (page 40)
-- #####################################################################

DELETE TBL_CUSTOMER_TEST
WHERE CUSTOMER_NO IN(5,6,7);

COMMIT;

INSERT INTO TBL_CUSTOMER_TEST
SELECT *
FROM TBL_CUSTOMER CUSTOMER_alt
WHERE NOT EXISTS (
SELECT 1 
FROM TBL_CUSTOMER_TEST CUSTOMER_neu 
WHERE CUSTOMER_neu.CUSTOMER_NO=CUSTOMER_alt.CUSTOMER_NO
);

COMMIT;

-- #####################################################################
--  Chapter 6: Example 9 (page 43)
-- #####################################################################

UPDATE TBL_CUSTOMER_TEST CUSTOMER_neu
SET GESCHLECHT=(
        SELECT UPPER(GESCHLECHT)
        FROM TBL_CUSTOMER CUSTOMER_alt
        WHERE CUSTOMER_alt.CUSTOMER_NO=CUSTOMER_neu.CUSTOMER_NO
);

COMMIT;

-- #####################################################################
--  Chapter 6: Example 10 (page 44)
-- #####################################################################

CREATE TABLE TBL_PRODUCT_TEST AS
SELECT *
FROM TBL_PRODUCT;

DELETE TBL_PRODUCT_TEST
WHERE PRODUCT_NO NOT IN(
            SELECT PRODUCT_NO
            FROM TBL_ORDER_POS
);

COMMIT;

-- #####################################################################
--  Chapter 6: Example 11 (page 44)
-- #####################################################################

SELECT *
FROM (
     SELECT CUSTOMER_NO, FIRSTNAME, SURNAME, DATE_OF_BIRTH
     FROM TBL_CUSTOMERS
     ORDER BY 4 ASC
)
WHERE ROWNUM<=3;




