-- #####################################################################
--  Chapter 6: Exercise 1
-- #####################################################################

SELECT  kunde.*,
        CITY.CITY_TURNOVER,
        round(kunde.KUNDE_TURNOVER/CITY.CITY_TURNOVER*100,1) AS ANTEIL
FROM (
        SELECT  k.CUSTOMER_NO,
                FIRSTNAME||' '||SURNAME AS KUNDE_NAME,
                k.CITY,
                SUM(bp.COUNT*p.PRICE) AS KUNDE_TURNOVER
        FROM TBL_CUSTOMERS k
          JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
          JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
        GROUP BY k.CUSTOMER_NO, FIRSTNAME, SURNAME, k.CITY
      ) kunde
JOIN (
        SELECT  k.CITY,
                SUM(bp.COUNT*p.PRICE) AS CITY_TURNOVER
        FROM TBL_CUSTOMERS k
          JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
          JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
        GROUP BY k.CITY
      ) CITY
ON kunde.CITY=CITY.CITY
ORDER BY 3,1;

-- #####################################################################
--  Chapter 6: Exercise 2
-- #####################################################################

select  prod.PRODUCT_NO,
        prod.NAME as PROD_NAME,
        grp_PRICE_avg.NAME as GRP_NAME,
        prod.PRICE,
        grp_PRICE_avg.avg_PRICE
from
(
    select grp.PRODUCT_GROUP_NO, grp.NAME, round(avg(p.PRICE),2) aS AVG_PRICE
    from TBL_PRODUCT_GROUP grp
      join tbl_PRODUCT p on grp.PRODUCT_GROUP_NO=p.PRODUCT_GROUP_NO
    group by grp.PRODUCT_GROUP_NO, grp.NAME
) grp_PRICE_avg
join tbl_PRODUCT prod on grp_PRICE_avg.PRODUCT_GROUP_NO=prod.PRODUCT_GROUP_NO
where prod.PRICE>grp_PRICE_avg.avg_PRICE
order by 1;

-- #####################################################################
--  Chapter 6: Exercise 3
-- #####################################################################

SELECT  distinct bp.ORDER_NO
FROM TBL_ORDER_POS bp 
WHERE PRODUCT_NO IN (
      
      SELECT  DISTINCT PRODUCT_NO
      FROM TBL_PRODUCT p
      WHERE PRICE>8
);

-- #####################################################################
--  Chapter 6: Exercise 4
-- #####################################################################

SELECT  distinct b.*
FROM TBL_ORDER b
  JOIN TBL_ORDER_POS bpos ON b.ORDER_NO=bpos.ORDER_NO
  JOIN TBL_PRODUCT p ON bpos.PRODUCT_NO=p.PRODUCT_NO
WHERE p.PRODUCT_GROUP_NO IN (
      
      SELECT  PRODUCT_GROUP_NO
      FROM TBL_PRODUCT p
      GROUP BY PRODUCT_GROUP_NO
      HAVING AVG(PRICE)>6
);

-- #####################################################################
--  Chapter 6: Exercise 5
-- #####################################################################

SELECT *
FROM TBL_EMPLOYEE
WHERE SALARY < 0.75*(
  SELECT AVG(SALARY)
  FROM TBL_EMPLOYEE
);

-- #####################################################################
--  Chapter 6: Exercise 6
-- #####################################################################

SELECT *
FROM TBL_EMPLOYEE m_main
WHERE SALARY>(
    SELECT AVG(SALARY)
    FROM TBL_EMPLOYEE m_sub
    WHERE m_sub.TYPE=m_main.TYPE
);

-- #####################################################################
--  Chapter 6: Exercise 7
-- #####################################################################

CREATE TABLE TBL_PROV_SALES_AGENT(
    SALES_AGENT_NO NUMBER(10),
    MONTH NUMBER(6),
    TURNOVER NUMBER(10,2),
    PROVISION NUMBER(10,2)
);

INSERT INTO TBL_PROV_SALES_AGENT (SALES_AGENT_NO, MONTH, TURNOVER)
SELECT  b.SALES_AGENT_NO,
        TO_NUMBER(TO_CHAR(ORDER_DATE,'YYYYMM')) AS MONTH,
        SUM(bpos.COUNT*p.PRICE) AS TURNOVER
FROM TBL_ORDER b
  JOIN TBL_ORDER_POS bpos ON b.ORDER_NO=bpos.ORDER_NO
  JOIN TBL_PRODUCT p ON bpos.PRODUCT_NO=p.PRODUCT_NO
GROUP BY  b.SALES_AGENT_NO,
          TO_NUMBER(TO_CHAR(ORDER_DATE,'YYYYMM'));
          
COMMIT; 

UPDATE TBL_PROV_SALES_AGENT prov
SET PROVISION=prov.TURNOVER*(
    SELECT PROV_FACTOR
    FROM TBL_EMPLOYEE m
    WHERE m.EMPLOYEE_NO=prov.SALES_AGENT_NO
);

COMMIT;

-- #####################################################################
--  Chapter 6: Exercise 1
-- #####################################################################

SELECT AVG(TURNOVER) AS AVG_TURNOVER
FROM (
    SELECT  b.ORDER_NO,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM TBL_ORDER b
      JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    GROUP BY b.ORDER_NO
);

--> Ergebnis als SubQuery in 2. Abfrage verwenden:

SELECT  b.ORDER_NO,
        SUM(bp.COUNT*p.PRICE) AS TURNOVER
FROM TBL_ORDER b
  JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO 
GROUP BY b.ORDER_NO
HAVING SUM(bp.COUNT*p.PRICE)>(
    SELECT AVG(TURNOVER) AS AVG_TURNOVER
    FROM (
        SELECT  b.ORDER_NO,
                SUM(bp.COUNT*p.PRICE) AS TURNOVER
        FROM TBL_ORDER b
          JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
        GROUP BY b.ORDER_NO
    )
);

-- #####################################################################
--  Chapter 6: Exercise 2
-- #####################################################################

Select  ORDER_DATE,
        SUM(bp.COUNT*p.PRICE) AS TURNOVER,
        MAX(ums_pro_mon.TURNOVER) AS TURNOVER_PRO_MONTH
from TBL_ORDER b
  JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
  JOIN (

    Select  TO_CHAR(ORDER_DATE,'YYYYMM') AS MONTH,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    from TBL_ORDER b
        JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
        JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    WHERE ORDER_DATE BETWEEN TO_DATE('01.01.2013', 'DD.MM.YYYY') AND TO_DATE('31.03.2013', 'DD.MM.YYYY')
    GROUP BY TO_CHAR(ORDER_DATE,'YYYYMM')
    
  ) ums_pro_mon ON ums_pro_mon.MONTH=to_char(b.ORDER_DATE,'YYYYMM')
WHERE ORDER_DATE BETWEEN TO_DATE('01.01.2013', 'DD.MM.YYYY') AND TO_DATE('31.03.2013', 'DD.MM.YYYY')
GROUP BY ORDER_DATE
ORDER BY ORDER_DATE;



-- #####################################################################
--  Chapter 6: Exercise 3
-- #####################################################################

SELECT  a.*,
        b.*,
        round(a.TURNOVER/b.GESAMT_TURNOVER,2) AS ANTEIL
FROM
(
    SELECT  k.CITY,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM TBL_CUSTOMERS k
      JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
      JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    GROUP BY k.CITY
) a,
(
    SELECT SUM(bp.COUNT*p.PRICE) AS GESAMT_TURNOVER
    FROM TBL_ORDER_POS bp
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
) b;

-- #####################################################################
--  Chapter 6: Exercise 4
-- #####################################################################

SELECT *
FROM TBL_PRODUCT_GROUP
WHERE PRODUCT_GROUP_NO NOT IN(
    SELECT DISTINCT p.PRODUCT_GROUP_NO
    FROM TBL_ORDER_POS bp
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
);

-- #####################################################################
--  Chapter 6: Exercise 5
-- #####################################################################

SELECT x.*
FROM (
    SELECT  k.CUSTOMER_NO,
            k.FIRSTNAME,
            k.SURNAME,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER_KUNDE
    FROM TBL_CUSTOMERS k
          JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
          JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    GROUP BY k.CUSTOMER_NO,
            k.FIRSTNAME,
            k.SURNAME
) x
WHERE x.TURNOVER_KUNDE>0.66*
  (
    SELECT TURNOVER_KUNDE
    FROM (
        SELECT  k.CUSTOMER_NO,
                SUM(bp.COUNT*p.PRICE) AS TURNOVER_KUNDE
        FROM TBL_CUSTOMERS k
              JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
              JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
              JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
        GROUP BY k.CUSTOMER_NO
        ORDER BY 2 DESC
    )
    WHERE ROWNUM=1
  )
ORDER BY 1;


-- #####################################################################
--  Chapter 6: Exercise 6a
-- #####################################################################

CREATE TABLE TBL_PRODUCT_TEST AS
SELECT * FROM TBL_PRODUCT WHERE 1=2;

INSERT INTO TBL_PRODUCT_TEST
SELECT *
FROM TBL_PRODUCT
WHERE PRICE>( SELECT AVG(PRICE) FROM TBL_PRODUCT);

COMMIT;

-- #####################################################################
--  Chapter 6: Exercise 6b
-- #####################################################################

ALTER TABLE TBL_PRODUCT_TEST ADD(AVG_PRICE_GRUPPE NUMBER(10,2));

UPDATE TBL_PRODUCT_TEST p
SET AVG_PRICE_GRUPPE= (
    SELECT AVG(PRICE) 
    FROM TBL_PRODUCT p2
    WHERE p2.PRODUCT_GROUP_NO=p.PRODUCT_GROUP_NO
    );
    
COMMIT; 

-- #####################################################################
--  Chapter 6: Exercise 7
-- #####################################################################

SELECT x.*
from
(
    SELECT  p.PRODUCT_NO,
            p.NAME,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM TBL_ORDER_POS bp
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    GROUP BY p.PRODUCT_NO,
            p.NAME
    ORDER BY 3 DESC
) x
where rownum<=3;


-- #####################################################################
--  Chapter 6: Exercise 8
-- #####################################################################

SELECT  a.*,
        (a.BEST_MAI/a.BEST_APRIL-1)*100 AS ABWEICHUNG
FROM (
    SELECT  m.FIRSTNAME,
            m.SURNAME,
            COUNT(DISTINCT b_april.ORDER_NO) AS BEST_APRIL,
            COUNT(DISTINCT b_mai.ORDER_NO) AS BEST_MAI
    FROM TBL_EMPLOYEE m
      JOIN TBL_ORDER b_april ON b_april.DRIVER_NO=m.EMPLOYEE_NO
      JOIN TBL_ORDER b_mai ON b_mai.DRIVER_NO=m.EMPLOYEE_NO
    WHERE to_char(b_april.ORDER_DATE,'YYYYMM')='201304'
    AND to_char(b_mai.ORDER_DATE,'YYYYMM')='201305'
    GROUP BY m.FIRSTNAME,
            m.SURNAME
) a;


-- #####################################################################
--  Chapter 6: Exercise 9
-- #####################################################################

SELECT DISTINCT CITY, PRODUCT_NO, NAME
FROM TBL_CUSTOMERS kunde_main, TBL_PRODUCT
WHERE PRODUCT_NO IN(
          SELECT x.PRODUCT_NO
          FROM(
              SELECT  k.CITY,
                      p.PRODUCT_NO,
                      p.NAME,
                      SUM(bp.COUNT*p.PRICE) AS TURNOVER
              FROM TBL_CUSTOMERS k
                JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
                JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
                JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
              GROUP BY  k.CITY,
                        p.PRODUCT_NO,
                        p.NAME
              ORDER BY 1,4 ASC
          ) x
          WHERE ROWNUM=1
          AND x.CITY=kunde_main.CITY        
)
ORDER BY 1,2;

