-- #####################################################################
--  Chapter 7: Exercise 1
-- #####################################################################

SELECT 'Top', x.*
FROM (
    SELECT  p.PRODUCT_NO,
            p.NAME,
            SUM(p.PRICE*bp.COUNT) AS TURNOVER
    FROM TBL_PRODUCT p
      JOIN TBL_ORDER_POS bp ON p.PRODUCT_NO=bp.PRODUCT_NO
    GROUP BY p.PRODUCT_NO,p.NAME
    ORDER BY 3 DESC
) x
WHERE ROWNUM<=2

UNION

SELECT 'Flop', x.*
FROM (
    SELECT  p.PRODUCT_NO,
            p.NAME,
            SUM(p.PRICE*bp.COUNT) AS TURNOVER
    FROM TBL_PRODUCT p
      JOIN TBL_ORDER_POS bp ON p.PRODUCT_NO=bp.PRODUCT_NO
    GROUP BY p.PRODUCT_NO,p.NAME
    ORDER BY 3 ASC
) x
WHERE ROWNUM<=2
ORDER BY 4 DESC;

-- #####################################################################
--  Chapter 7: Exercise 2
-- #####################################################################

SELECT  DISTINCT 
        p.PRODUCT_NO,
        p.NAME        
FROM TBL_CUSTOMERS k
  JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
  JOiN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
WHERE k.GENDER IN('m','M')

INTERSECT

SELECT  DISTINCT 
        p.PRODUCT_NO,
        p.NAME        
FROM TBL_CUSTOMERS k
  JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
  JOiN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
WHERE k.GENDER IN('f','F');

-- #####################################################################
--  Chapter 7: Exercise 3
-- #####################################################################

SELECT PRODUCT_NO, NAME
FROM TBL_PRODUCT

MINUS

SELECT DISTINCT
        p.PRODUCT_NO,
        p.NAME
FROM TBL_ORDER_POS bp
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO;

-- #####################################################################
--  Chapter 7: Exercise 1
-- #####################################################################

SELECT *
FROM (

    SELECT  'Hamburg' AS CITY,
            p.PRODUCT_NO,
            p.NAME,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM TBL_CUSTOMERS k
      JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
      JOiN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    WHERE k.CITY='Hamburg'
    GROUP BY 'Hamburg', p.PRODUCT_NO,p.NAME
    ORDER BY 4 DESC
)
where rownum=1

UNION

SELECT *
FROM(
    SELECT  'Kiel' AS CITY,
            p.PRODUCT_NO,
            p.NAME,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM TBL_CUSTOMERS k
      JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
      JOiN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    WHERE k.CITY='Kiel'
    GROUP BY 'Kiel', p.PRODUCT_NO,p.NAME
    ORDER BY 4 DESC
)
WHERE rownum=1;

-- #####################################################################
--  Chapter 7: Exercise 2
-- #####################################################################

SELECT CITY
FROM (
    SELECT k.CITY, SUM(bp.COUNT*p.PRICE)
    FROM TBL_CUSTOMERS k
          JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
          JOiN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    GROUP BY k.CITY
    ORDER BY 2 DESC
)
WHERE rownum<=2

INTERSECT

SELECT CITY
FROM (
    SELECT k.CITY, COUNT(distinct b.ORDER_NO)
    FROM TBL_CUSTOMERS k
          JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
    GROUP BY k.CITY
    ORDER BY 2 DESC
)
WHERE rownum<=2;

-- #####################################################################
--  Chapter 7: Exercise 3
-- #####################################################################

INSERT INTO TBL_PRODUCT_TEST (PRODUCT_NO, NAME, PRICE, PRODUCT_GROUP_NO)
SELECT *
FROM TBL_PRODUCT
MINUS
SELECT PRODUCT_NO, NAME, PRICE, PRODUCT_GROUP_NO
FROM TBL_PRODUCT_TEST;

COMMIT;

-- #####################################################################
--  Chapter 7: Exercise 4
-- #####################################################################

SELECT NO, NAME, TURNOVER
FROM (
    SELECT  p.PRODUCT_GROUP_NO*1000+p.PRODUCT_NO AS SORT_COLUMN,
            p.PRODUCT_GROUP_NO||'-'||p.PRODUCT_NO AS NO,
            p.NAME,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM  TBL_ORDER_POS bp
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    GROUP BY  p.PRODUCT_GROUP_NO*1000+p.PRODUCT_NO,
              p.PRODUCT_GROUP_NO||'-'||p.PRODUCT_NO,
              p.NAME
    
    UNION
    
    SELECT  pg.PRODUCT_GROUP_NO*1000+999 AS SCITYIERUNG,
            to_char(pg.PRODUCT_GROUP_NO),
            pg.NAME,
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM  TBL_ORDER_POS bp
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
          JOIN TBL_PRODUCT_GROUP pg ON p.PRODUCT_GROUP_NO=pg.PRODUCT_GROUP_NO
    GROUP BY  pg.PRODUCT_GROUP_NO*1000,
              to_char(pg.PRODUCT_GROUP_NO),
              pg.NAME
    
    UNION
    
    SELECT  100000 AS SCITYIERUNG,
            '0',
            'GESAMT',
            SUM(bp.COUNT*p.PRICE) AS TURNOVER
    FROM  TBL_ORDER_POS bp
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    GROUP BY  10000, '0', 'GESAMT'
) 
ORDER BY SORT_COLUMN;
