-- #####################################################################
--  Chapter 8: Example 1 (page 11)
-- #####################################################################

CREATE TABLE TBL_CUSTOMERS(
CUSTOMER_NO    NUMBER(10,0) NOT NULL,
FIRSTNAME   VARCHAR2(25) NOT NULL,
SURNAME   VARCHAR2(25) NOT NULL,
STREET VARCHAR2(50),
ZIP_CODE   VARCHAR2(5),
CITY     VARCHAR2(20),
GENDER VARCHAR2(1) CHECK (GENDER IN('M', 'F', 'm', 'f')),
DATE_OF_BIRTH DATE DEFAULT TO_DATE('01.01.1900' ,'DD.MM.YYYY')
);

-- #####################################################################
--  Chapter 8: Example 2 (page 12)
-- #####################################################################

RENAME TBL_CUSTOMERS TO TBL_CUSTOMERS2;

-- #####################################################################
--  Chapter 8: Example 3 (page 12)
-- #####################################################################

DROP TABLE TBL_CUSTOMERS2;

-- #####################################################################
--  Chapter 8: Example 4 (page 12)
-- #####################################################################

CREATE TABLE TBL_PRODUCT_GROUP(
PRODUCT_GROUP_NO   NUMBER(5,0) NOT NULL,
NAME   VARCHAR2(25),
CONSTRAINT PK_PRODGROUP PRIMARY KEY (PRODUKT_GROUP_NO)
);

-- #####################################################################
--  Chapter 8: Example 5 (page 13)
-- #####################################################################

CREATE TABLE TBL_PRODUCT(
PRODUCT_NO   NUMBER(5, 0) NOT NULL,
NAME   VARCHAR2(25),
PRICE  NUMBER(10,2),
PRODUCT_GROUP_NO   NUMBER(5, 0) NOT NULL,
CONSTRAINT PK_PRODUCT PRIMARY KEY (PRODUCT_NO),
CONSTRAINT FK_PROD_PROD_GROUP FOREIGN KEY (PRODUCT_GROUP_NO)
REFERENCES TBL_PRODUCT_GROUP(PRODUCT_GROUP_NO)
);

-- #####################################################################
--  Chapter 8: Example 6 (page 13)
-- #####################################################################

INSERT INTO TBL_PRODUCT VALUES(1, 'Rumpsteak', 20.95, 1);

COMMIT;

-- #####################################################################
--  Chapter 8: Example 7 (page 13)
-- #####################################################################

INSERT INTO TBL_PRODUCT_GROUP VALUES(1, 'Meat dishes');
COMMIT;

INSERT INTO TBL_PRODUCT VALUES(1, 'Rumpsteak', 20.95, 1);
COMMIT;

-- #####################################################################
--  Chapter 8: Example 8 (page 14)
-- #####################################################################

ALTER TABLE TBL_PRODUCT DISABLE CONSTRAINT FK_PROD_PROD_GROUP;

-- #####################################################################
--  Chapter 8: Example 9 (page 14)
-- #####################################################################

ALTER TABLE TBL_PRODUCT ENABLE CONSTRAINT FK_PROD_PROD_GROUP;

-- #####################################################################
--  Chapter 8: Example 10 (page 14)
-- #####################################################################

ALTER TABLE TBL_CUSTOMERS ADD (TEST  VARCHAR2(10) DEFAULT 'n/a' NOT NULL);

-- #####################################################################
--  Chapter 8: Example 11 (page 14)
-- #####################################################################

ALTER TABLE TBL_CUSTOMERS MODIFY (TEST NUMBER DEFAULT -1);

-- #####################################################################
--  Chapter 8: Example 12 (page 15)
-- #####################################################################

INSERT INTO TBL_CUSTOMERS 
VALUES (1, 'Horst', 'Huber', 'Karolinenweg 11a', '20357', 'Hamburg', 'M', to_date('01.05.1947', 'DD.MM.YYYY'), null);

COMMIT;

-- #####################################################################
--  Chapter 8: Example 13 (page 15)
-- #####################################################################

INSERT INTO TBL_CUSTOMERS (CUSTOMER_NO, FIRSTNAME, SURNAME)
VALUES (2, 'Erika', 'Schmidt');

INSERT INTO TBL_CUSTOMERS (CUSTOMER_NO, FIRSTNAME, SURNAME)
VALUES (3, 'Bert', 'Mueller');

COMMIT;


-- #####################################################################
--  Chapter 8: Example 14 (page 16)
-- #####################################################################

UPDATE TBL_CUSTOMERS
SET Street='GoetheStreet 5', ZIP_CODE='22512', City='Hamburg'
WHERE CUSTOMER_NO=2;

UPDATE TBL_CUSTOMERS
SET Street='Schwedenweg 22', ZIP_CODE='22123', City='Hamburg'
WHERE CUSTOMER_NO=3;

COMMIT;

-- #####################################################################
--  Chapter 8: Example 15 (page 16)
-- #####################################################################

ALTER TABLE TBL_PRODUCT ADD (PRICE_NEW NUMBER);

UPDATE TBL_PRODUCT
SET PRICE_NEW=PRICE*5;

COMMIT;

SELECT *
FROM TBL_PRODUCT;

-- #####################################################################
--  Chapter 8: Example 16 (page 16)
-- #####################################################################

DELETE TBL_CUSTOMERS
WHERE CUSTOMER_NO=2;

COMMIT;

SELECT *
FROM TBL_CUSTOMERS;

-- #####################################################################
--  Chapter 8: Example 17 (page 17)
-- #####################################################################

ALTER TABLE TBL_ORDER DISABLE CONSTRAINT FK_ORDER_CUSTOMER;

TRUNCATE TABLE TBL_CUSTOMERS;

ALTER TABLE TBL_ORDER ENABLE CONSTRAINT FK_ORDER_CUSTOMER;

SELECT *
FROM TBL_CUSTOMERS;
