-- #####################################################################
--  Chapter 8: Exercise 1
-- #####################################################################

CREATE TABLE TBL_EMPLOYEE(
  EMPLOYEE_NO	NUMBER(10),
  FIRSTNAME	VARCHAR2(30),
  SURNAME VARCHAR2(30),
  TYPE	VARCHAR2(20),
  SALARY	NUMBER(10,2),
  PROV_FACTOR NUMBER(10,2)
);


-- #####################################################################
--  Chapter 8: Exercise 2
-- #####################################################################

DROP TABLE TBL_CUSTOMERS;

CREATE TABLE TBL_CUSTOMERS(
  CUSTOMER_NO	NUMBER(10,0) NOT NULL ,
  FIRSTNAME VARCHAR2(25) NOT NULL,	
  SURNAME VARCHAR2(25) NOT NULL,
  STREET	 VARCHAR2(50),
  ZIP_CODE	 VARCHAR2(5),
  CITY	 VARCHAR2(20),
  GENDER VARCHAR2(1) CHECK(GENDER IN('M', 'm', 'F', 'f')),	
  DATE_OF_BIRHT DATE DEFAULT TO_DATE('01.01.1900', 'DD.MM.YYYY'),
  CONSTRAINT PK_CUSTOMER PRIMARY KEY (CUSTOMER_NO)
);

CREATE TABLE TBL_ORDER(
  ORDER_NO NUMBER(10,0) NOT NULL,	
  ORDER_DATE DATE NOT NULL,	
  CUSTOMER_NO NUMBER(10,0) NOT NULL,	
  DRIVER_NO	NUMBER(10,0),
  SALES_AGENT_NO NUMBER(10,0),
  CONSTRAINT PK_ORDER PRIMARY KEY (ORDER_NO),
  CONSTRAINT FK_ORDER_CUSTOMER FOREIGN KEY (CUSTOMER_NO)
      REFERENCES TBL_CUSTOMERs(CUSTOMER_NO)
);

-- #####################################################################
--  Chapter 8: Exercise 3
-- #####################################################################

ALTER TABLE TBL_CUSTOMERs DROP(TEST);

ALTER TABLE TBL_CUSTOMERs ADD(CREATION_DATE DATE DEFAULT SYSDATE);

-- #####################################################################
--  Chapter 8: Exercise 4
-- #####################################################################

ALTER TABLE TBL_EMPLOYEE ADD CONSTRAINT PK_EMPLOYEE PRIMARY KEY (EMPLOYEE_NO);
ALTER TABLE TBL_ORDER ADD CONSTRAINT FK_ORDER_SALES_AGENT FOREIGN KEY (SALES_AGENT_NO)
      REFERENCES TBL_EMPLOYEE(SALES_AGENT_NO);

-- #####################################################################
--  Chapter 8: Exercise 1
-- #####################################################################

INSERT INTO TBL_CUSTOMERs (CUSTOMER_NO, VORNAME, NACHNAME) VALUES(1, 'Hugo', 'Schmidt');

COMMIT;

-- #####################################################################
--  Chapter 8: Exercise 2
-- #####################################################################

CREATE TABLE TBL_ORDER_POS(
  ORDER_NO NUMBER(10) NOT NULL,	
  PRODUCT_NO NUMBER(10) NOT NULL	,
  COUNT NUMBER(10) NOT NULL,
  CONSTRAINT PK_ORDER_POS PRIMARY KEY(ORDER_NO, PRODUCT_NO),
  CONSTRAINT FK_BEST_POS_BEST FOREIGN KEY(ORDER_NO)
    REFERENCES TBL_ORDER(ORDER_NO)
);

INSERT INTO TBL_ORDER VALUES(1, sysdate, 0, 1, 0, 0);

commit;

INSERT INTO TBL_ORDER_POS VALUES(1,25,1);

commit;

-- #####################################################################
--  Chapter 8: Exercise 3
-- #####################################################################

ALTER TABLE TBL_ORDER_POS ADD CONSTRAINT FK_ORDER_POS_PRODUCT FOREIGN KEY(PRODUCT_NO)
  REFERENCES TBL_PRODUCT(PRODUCT_NO);

--> Fehler, weil PRODUCT NO.1 in PRODUCT Tabelle nicht zu PRODUCT NO. 25 in ORDER-Pos passt.
--> Wir ndern den Satz in ORDER-Pos und erstellen den Constraint erneut.

UPDATE TBL_ORDER_POS SET PRODUCT_NO=1 WHERE PRODUCT_NO=25;

COMMIT;

ALTER TABLE TBL_ORDER_POS ADD CONSTRAINT FK_ORDER_POS_PRODUCT FOREIGN KEY(PRODUCT_NO)
  REFERENCES TBL_PRODUCT(PRODUCT_NO);


-- #####################################################################
--  Chapter 8: Exercise 4
-- #####################################################################

DELETE TBL_ORDER_POS;

COMMIT;


DELETE TBL_ORDER;

COMMIT;

-- #####################################################################
--  Chapter 8: Exercise 5
-- #####################################################################

ALTER TABLE TBL_CUSTOMERs DROP(ERSTELLDATUM);

-- #####################################################################
--  Chapter 8: Exercise 6
-- #####################################################################

DELETE TBL_PRODUCT;
DELETE TBL_PRODUCT_GROUP;
DELETE TBL_CUSTOMERs;
COMMIT;

-- Skript TBL_PRODUCT_GROUP_INSERT ausfhren
-- Skript TBL_PRODUCT_INSERT ausfhren
-- Skript TBL_EMPLOYEE_INSERT ausfhren
-- Skript TBL_CUSTOMERs_INSERT ausfhren
-- Skript TBL_ORDER_INSERT ausfhren
-- Skript TBL_ORDER_POS_INSERT ausfhren
