-- #####################################################################
--  Chapter 11a: Example 1 (page 51)
-- #####################################################################

CREATE OR REPLACE VIEW V_CUSTOMERS_HAMBURG AS
SELECT *
FROM TBL_CUSTOMERS
WHERE CITY='Hamburg';


SELECT CUSTOMER_NO, FIRSTNAME, SURNAME, ZIP_CODE, CITY
FROM V_CUSTOMERS_HAMBURG;

-- #####################################################################
--  Chapter 11a: Example 2 (page 51)
-- #####################################################################

CREATE VIEW V_ANZ_ORDERS_CUSTOMERS_HH AS
SELECT  k.CUSTOMER_NO, k.FIRSTNAME, k.SURNAME, 
              Count(distinct b.ORDER_NO) AS ANZ_ORDERS
FROM V_CUSTOMERS_HAMBURG k
     JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
GROUP BY k.CUSTOMER_NO, k.FIRSTNAME, k.SURNAME;

SELECT *
FROM V_ANZ_ORDERS_CUSTOMERS_HH;

-- #####################################################################
--  Chapter 11a: Example 3 (page 51)
-- #####################################################################

DROP VIEW V_ANZ_ORDERS_CUSTOMERS_HH;

-- #####################################################################
--  Chapter 11a: Example 4 (page 52)
-- #####################################################################

GRANT SELECT ON TBL_CUSTOMERS TO TEST2, TEST3;

-- #####################################################################
--  Chapter 11a: Example 5 (page 53)
-- #####################################################################

REVOKE SELECT ON TBL_CUSTOMERS FROM TEST2;

-- #####################################################################
--  Chapter 11a: Example 6 (page 54)
-- #####################################################################

SELECT PRODUCT_NO, NAME, TURNOVER,
             CASE
                 WHEN TURNOVER<700 THEN 'A'
                 WHEN TURNOVER BETWEEN 700 AND 1000 THEN 'B'
                 ELSE 'C'
             END AS TURNOVER_GROUP
FROM V_TURNOVER_PRODUCT
ORDER BY 3 ASC;

-- #####################################################################
--  Chapter 11a: Example 7 (page 54)
-- #####################################################################

SELECT x.*,
       DECODE(TURNOVER_GROUP, 'A', '0 ... 700', 'B', '>700 ... 1000', '>1000 ... ') AS GROUP_BEZ 
FROM (
    SELECT PRODUCT_NO, NAME, TURNOVER,
                 CASE
                     WHEN TURNOVER<700 THEN 'A'
                     WHEN TURNOVER BETWEEN 700 AND 1000 THEN 'B'
                     ELSE 'C'
                 END AS TURNOVER_GROUP
    FROM V_TURNOVER_PRODUCT
    ORDER BY 3 ASC
) x;

-- #####################################################################
--  Chapter 11a: Example 8 (page 54)
-- #####################################################################

SELECT DISTINCT
     grp.PRODUCT_GROUP_NO,
     grp.NAME,
     SUM(ums.TURNOVER) OVER() AS TURNOVER_GESAMT,
     SUM(ums.TURNOVER) OVER(PARTITION BY grp.PRODUCT_GROUP_NO) AS TURNOVER_GROUP,
     round(SUM(ums.TURNOVER) OVER(PARTITION BY grp.PRODUCT_GROUP_NO)
     /SUM(ums.TURNOVER) OVER(),2) AS ANTEIL
FROM V_TURNOVER_PRODUCT ums
      JOIN TBL_PRODUCT_GROUP grp ON ums.PRODUCT_GROUP_NO=grp.PRODUCT_GROUP_NO
ORDER BY 1;      

-- #####################################################################
--  Chapter 11a: Example 9 (page 54)
-- #####################################################################

SELECT DISTINCT 
    x.*,
    SUM(TURNOVER) OVER(
      ORDER BY MONAT ASC
      ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW
    ) AS TURNOVER_KUM    
FROM (
    SELECT DISTINCT
        to_char(b.ORDER_DATE,'MM/YYYY') AS MONAT,
        SUM(bp.COUNT*p.PRICE) OVER(PARTITION BY to_char(b.ORDER_DATE,'MM/YYYY')) AS TURNOVER
    FROM TBL_ORDER b
      JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    WHERE to_char(b.ORDER_DATE,'YYYY')='2013'
) x
ORDER BY 1;
