-- #####################################################################
--  Chapter11a: Exercise 1
-- #####################################################################

CREATE VIEW V_TURNOVER_PRODUCT AS
SELECT  p.PRODUCT_GROUP_NO,
        p.PRODUCT_NO,
        p.NAME,
        p.PRICE,
        SUM(bp.COUNT*p.PRICE) AS TURNOVER
FROM TBL_ORDER_POS bp 
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
GROUP BY p.PRODUCT_GROUP_NO,
        p.PRODUCT_NO,
        p.NAME,
        p.PRICE
ORDER BY 1,2;

-- #####################################################################
--  Chapter11a: Exercise 2
-- #####################################################################

CREATE VIEW V_SEC_KUNDE AS
SELECT CUSTOMER_NO, FIRSTNAME, SURNAME
FROM TBL_CUSTOMERS;

GRANT SELECT ON V_SEC_KUNDE TO TEST3;


-- #####################################################################
--  Chapter11a: Exercise 3
-- #####################################################################

SELECT  CUSTOMER_NO,
        CASE WHEN ANZ_ORDEREN>5 THEN 'ja' ELSE 'nein' END AS MEHR_ALS_5_BEST
FROM (
    SELECT k.CUSTOMER_NO, Count(distinct ORDER_NO) AS ANZ_ORDEREN
    FROM TBL_CUSTOMERS k
      JOIN TBL_ORDER b ON k.CUSTOMER_NO=b.CUSTOMER_NO
    GROUP BY k.CUSTOMER_NO
)
ORDER BY 1;

-- #####################################################################
--  Chapter11a: Exercise 4
-- #####################################################################

SELECT DISTINCT
    p.PRODUCT_NO,
    p.NAME,
    SUM(bp.COUNT*p.PRICE) OVER (PARTITION BY p.PRODUCT_NO) AS TURNOVER,
    SUM(bp.COUNT*p.PRICE) OVER (PARTITION BY p.PRODUCT_GROUP_NO) AS TURNOVER_GRP
FROM TBL_ORDER_POS bp
  JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
ORDER BY 1 ASC;

-- #####################################################################
--  Chapter11a: Exercise 35 (Seite 54)
-- #####################################################################

SELECT DISTINCT 
    x.*,
    SUM(TURNOVER) OVER(
      ORDER BY MONAT ASC
      ROWS BETWEEN 1 PRECEDING AND 1 PRECEDING
    ) AS TURNOVER_KUM    
FROM (
    SELECT DISTINCT
        to_char(b.ORDER_DATE,'MM/YYYY') AS MONAT,
        SUM(bp.COUNT*p.PRICE) OVER(PARTITION BY to_char(b.ORDER_DATE,'MM/YYYY')) AS TURNOVER
    FROM TBL_ORDER b
      JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
    WHERE to_char(b.ORDER_DATE,'YYYY')='2013'
) x
ORDER BY 1;


-- #####################################################################
--  Chapter11a: Exercise 1
-- #####################################################################

--> Anmelden als Benutzer TEST

REVOKE ALL PRIVILEGES ON TBL_CUSTOMERS FROM PUBLIC;

GRANT UPDATE (PRICE) ON TBL_PRODUCT TO TEST2;

GRANT SELECT ON TBL_PRODUCT TO TEST2;

--> Anmelden als Benutzer TEST2 und Test der Rechte

Select *
from TEST.TBL_CUSTOMERS; --> Sollte nicht mglich sein.


UPDATE TEST.TBL_PRODUCT
SET PRICE=1.0
WHERE PRODUCT_NO=16;

COMMIT;

Select *
from TEST.TBL_PRODUCT;

-- #####################################################################
--  Chapter11a: Exercise 2
-- #####################################################################

CREATE VIEW V_TURNOVER_TOTAL AS
SELECT SUM(TURNOVER) AS TURNOVER_TOTAL
FROM V_TURNOVER_PRODUCT;

ALTER TABLE TBL_PRODUCT ADD(TURNOVER_PRODUCT NUMBER(10,2));

UPDATE TBL_PRODUCT p
SET TURNOVER_PRODUCT= (SELECT TURNOVER FROM V_TURNOVER_PRODUCT WHERE PRODUCT_NO=p.PRODUCT_NO);

commit;

ALTER TABLE TBL_PRODUCT ADD(TURNOVER_ANTEIL NUMBER(10,2));

UPDATE TBL_PRODUCT
SET TURNOVER_ANTEIL=round(TURNOVER_PRODUCT/(SELECT TURNOVER_TOTAL FROM V_TURNOVER_TOTAL),2);

commit;

-- #####################################################################
--  Chapter11a: Exercise 3
-- #####################################################################

SELECT DISTINCT
      x.PRODUCT_GROUP_NO,
      FIRST_VALUE(NAME) OVER(PARTITION BY x.PRODUCT_GROUP_NO ORDER BY PRODUCT_GROUP_NO, UMS_PROD DESC) TOP_NACH_TURNOVER,
      FIRST_VALUE(NAME) OVER(PARTITION BY x.PRODUCT_GROUP_NO ORDER BY PRODUCT_GROUP_NO, BEST_PROD DESC) TOP_NACH_BEST
FROM (
    SELECT DISTINCT
          grp.PRODUCT_GROUP_NO,
          p.PRODUCT_NO,
          p.NAME,
          SUM(bp.COUNT*p.PRICE) OVER(PARTITION BY p.PRODUCT_NO) UMS_PROD,
          COUNT(distinct b.ORDER_NO) OVER(PARTITION BY p.PRODUCT_NO) BEST_PROD
    FROM TBL_ORDER b
          JOIN TBL_ORDER_POS bp ON b.ORDER_NO=bp.ORDER_NO
          JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
          JOIN TBL_PRODUCT_GROUP grp ON p.PRODUCT_GROUP_NO=grp.PRODUCT_GROUP_NO
) x
ORDER BY 1;

-- #####################################################################
--  Chapter11a: Exercise 4
-- #####################################################################

SELECT x.*,
       DENSE_RANK() OVER(PARTITION BY GRP_NO ORDER BY UMS_PROD DESC) AS RANK_GRP,
       DENSE_RANK() OVER(ORDER BY UMS_PROD DESC) AS RANK_GES,
       CASE WHEN (DENSE_RANK() OVER(PARTITION BY GRP_NO ORDER BY UMS_PROD DESC))=1 THEN '*' ELSE ' ' END AS TOP
FROM (       
    SELECT  DISTINCT
            grp.PRODUCT_GROUP_NO AS GRP_NO,
            grp.NAME AS GRP_BEZ,
            p.PRODUCT_NO,
            p.NAME AS PRODUCT_BEZ,
            SUM(bp.COUNT*p.PRICE) OVER(PARTITION BY p.PRODUCT_NO) AS UMS_PROD
    FROM TBL_ORDER_POS bp
      JOIN TBL_PRODUCT p ON bp.PRODUCT_NO=p.PRODUCT_NO
      JOIN TBL_PRODUCT_GROUP grp ON p.PRODUCT_GROUP_NO=grp.PRODUCT_GROUP_NO
) x
ORDER by 1,6;